﻿using System;
using System.Threading;

// 이 예제 코드를 Debug와 Release 모드로 각각 컴파일해 실행해 보면 차이점을 확인할 수 있습니다.
// 또는 Release 컴파일 상태에서 m_resultState 필드의 volatile 예약어 적용 유무에 따라 달라집니다.
public class TestClass
{
    /* volatile */ bool m_resultState;
    bool m_terminate;

    public static void Start(object obj)
    {
        TestClass tc = obj as TestClass;
        int k = 0;

        while (tc.m_terminate == false)
        {
            Console.WriteLine(k++);
            Thread.Sleep(1000);
        }

        tc.m_resultState = true;

        Console.WriteLine("m_resultState == " + tc.m_resultState);
    }

    public void endThread()
    {
        m_terminate = true;

        while (true)
        {
            if (true == result())
            {
                Console.WriteLine("result() == true");
                break;
            }
        }
    }

    bool result() { return m_resultState; }
}

public class WorkerThreadExample
{
    static void Main()
    {
        TestClass testClass = new TestClass();

        Thread t1 = new Thread(TestClass.Start);
        t1.Start(testClass);
        Thread.Sleep(2000);

        testClass.endThread();
    }
}


